# include "relastro.h"

int load_images (FITS_DB *db, SkyList *skylist, int UseFullOverlap) {

  Image     *image, *subset;
  off_t      Nimage, Nsubset;
  off_t     *LineNumber;

  INITTIME;

  // convert database table to internal structure
  image = gfits_table_get_Image (&db[0].ftable, &Nimage, &db[0].swapped);
  if (!image) {
      fprintf (stderr, "ERROR: failed to read images\n");
      exit (2);
  }
  MARKTIME("  convert image table: %f sec\n", dtime);

  // select the images which overlap the selected sky regions
  subset = select_images (skylist, image, Nimage, &LineNumber, &Nsubset, UseFullOverlap);
  MARKTIME("  select images: %f sec\n", dtime);

  initImages (subset, LineNumber, Nsubset);
  MARKTIME("  init images: %f sec\n", dtime);

  initMosaics (subset, Nsubset);
  MARKTIME("  init mosaics: %f sec\n", dtime);
  
  /* unlock, if we can (else, unlocked below) */
  int unlockImages = !UPDATE || (RELASTRO_OP == OP_UPDATE_OFFSETS);
  if (unlockImages) dvo_image_unlock (db); 

  return TRUE;
}

int reload_images (FITS_DB *db) {

  Image     *image;
  off_t     Nimage, Nx, i, *LineNumber;
  VTable    *vtable;

  image = getimages (&Nimage, &LineNumber);

  gfits_vtable_from_ftable (&db[0].ftable, &db[0].vtable, LineNumber, Nimage);
  vtable = &db[0].vtable;

  gfits_scan (vtable[0].header, "NAXIS1", OFF_T_FMT, 1,  &Nx);
  for (i = 0; i < Nimage; i++) {
    memcpy (vtable[0].buffer[i], &image[i], Nx);
  }
  return TRUE;
}
